import .connectives
import .leibniz
import .logic
import .relations
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
axiom nat.match_nat_prop : forall (return:(nat.nat) -> Prop) , ((return) ((nat.O) )) -> (forall (n:nat.nat) , (return) (((nat.S) ) (n))) -> forall (z:nat.nat) , (return) (z).
constant nat.match_nat_type : forall (return : Type) , (return) -> ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_match_nat_type_O : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O).
theorem nat.eq_match_nat_type_O : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O)) ((((@nat.axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
axiom nat.axiom_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)).
theorem nat.eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
theorem nat.sym_eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((case_S) (n))) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
axiom nat.nat_ind : forall (Q:(nat.nat) -> Prop) , ((Q) ((nat.O) )) -> (forall (x:nat.nat) , ((Q) (x)) -> (Q) (((nat.S) ) (x))) -> forall (x:nat.nat) , (Q) (x).
noncomputable def nat.pred_ : (nat.nat) -> nat.nat := fun (n : nat.nat) , ((((nat.match_nat_type) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (n).
def nat.not_zero : (nat.nat) -> Prop := fun (n : nat.nat) , ((((nat.match_nat_type) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (n).
constant nat.le_ : (nat.nat) -> (nat.nat) -> Prop.
axiom nat.le_n : forall (n:nat.nat) , (((nat.le_) ) (n)) (n).
axiom nat.le_S : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (((nat.le_) ) (n)) (((nat.S) ) (m)).
axiom nat.le_ind : forall (n:nat.nat) , forall (Q:(nat.nat) -> Prop) , ((Q) (n)) -> (forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> ((Q) (m)) -> (Q) (((nat.S) ) (m))) -> forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (Q) (m).
def nat.lt_ : (nat.nat) -> (nat.nat) -> Prop := fun (n : nat.nat) , fun (m : nat.nat) , (((nat.le_) ) (((nat.S) ) (n))) (m).
theorem nat.nat_elim2 : forall (R:(nat.nat) -> (nat.nat) -> Prop) , (forall (n:nat.nat) , ((R) ((nat.O) )) (n)) -> (forall (n:nat.nat) , ((R) (((nat.S) ) (n))) ((nat.O) )) -> (forall (n:nat.nat) , forall (m:nat.nat) , (((R) (n)) (m)) -> ((R) (((nat.S) ) (n))) (((nat.S) ) (m))) -> forall (n:nat.nat) , forall (m:nat.nat) , ((R) (n)) (m) := fun (R : (nat.nat) -> (nat.nat) -> Prop) , fun (ROn : forall (n:nat.nat) , ((R) ((nat.O) )) (n)) , (fun (RSO : forall (n:nat.nat) , ((R) (((nat.S) ) (n))) ((nat.O) )) , (fun (RSS : forall (n:nat.nat) , forall (m:nat.nat) , (((R) (n)) (m)) -> ((R) (((nat.S) ) (n))) (((nat.S) ) (m))) , (fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (m:nat.nat) , ((R) (_x_365)) (m))) (fun (m : nat.nat) , (ROn) (m))) (fun (n0 : nat.nat) , fun (Rn0m : forall (m:nat.nat) , ((R) (n0)) (m)) , (fun (m : nat.nat) , ((((@nat.match_nat_prop) (fun (__ : nat.nat) , ((R) (((nat.S) ) (n0))) (__))) ((RSO) (n0))) (fun (auto : nat.nat) , (((RSS) (n0)) (auto)) ((Rn0m) (auto)))) (m)))) (n)))).
theorem nat.pred_Sn : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) (n)) (((nat.pred_) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((((@nat.sym_eq_match_nat_type_S) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (n)) (fun (y : nat.nat) , (((logic.eq_) (nat.nat)) (n)) (y))) (((@logic.refl_) (nat.nat)) (n)).
theorem nat.lt_to_not_zero : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.lt_) ) (n)) (m)) -> ((nat.not_zero) ) (m) := fun (n : nat.nat) , fun (m : nat.nat) , fun (Hlt : (((nat.lt_) ) (n)) (m)) , (((((((@nat.le_ind) (((nat.S) ) (n))) (fun (x_417 : nat.nat) , ((nat.not_zero) ) (x_417))) (((((((@nat.sym_eq_match_nat_type_S) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (n)) (fun (y : Prop) , y)) (@connectives.I))) (fun (m0 : nat.nat) , fun (_x_419 : (((nat.le_) ) (((nat.S) ) (n))) (m0)) , (fun (_x_421 : ((nat.not_zero) ) (m0)) , (((((((@nat.sym_eq_match_nat_type_S) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (m0)) (fun (y : Prop) , y)) (@connectives.I))))) (m)) (Hlt)).
theorem nat.le_S_S : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m)) := fun (n : nat.nat) , fun (m : nat.nat) , fun (lenm : (((nat.le_) ) (n)) (m)) , (((((((@nat.le_ind) (n)) (fun (x_417 : nat.nat) , (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (x_417)))) ((@nat.le_n) (((nat.S) ) (n)))) (fun (m0 : nat.nat) , fun (_x_419 : (((nat.le_) ) (n)) (m0)) , (fun (_x_421 : (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m0))) , ((((@nat.le_S) (((nat.S) ) (n))) (((nat.S) ) (m0))) (_x_421))))) (m)) (lenm)).
theorem nat.le_O_n : forall (n:nat.nat) , (((nat.le_) ) ((nat.O) )) (n) := fun (n : nat.nat) , ((((@nat.nat_ind) (((nat.le_) ) ((nat.O) ))) ((@nat.le_n) ((nat.O) ))) (fun (x_366 : nat.nat) , fun (_x_368 : (((nat.le_) ) ((nat.O) )) (x_366)) , ((((@nat.le_S) ((nat.O) )) (x_366)) (_x_368)))) (n).
theorem nat.le_n_Sn : forall (n:nat.nat) , (((nat.le_) ) (n)) (((nat.S) ) (n)) := fun (n : nat.nat) , (((@nat.le_S) (n)) (n)) ((@nat.le_n) (n)).
theorem nat.transitive_le : ((relations.transitive) (nat.nat)) ((nat.le_) ) := fun (a : nat.nat) , fun (b : nat.nat) , fun (c : nat.nat) , fun (leab : (((nat.le_) ) (a)) (b)) , (fun (lebc : (((nat.le_) ) (b)) (c)) , (((((((@nat.le_ind) (b)) (fun (x_417 : nat.nat) , (((nat.le_) ) (a)) (x_417))) (leab)) (fun (m : nat.nat) , fun (_x_419 : (((nat.le_) ) (b)) (m)) , (fun (_x_421 : (((nat.le_) ) (a)) (m)) , ((((@nat.le_S) (a)) (m)) (_x_421))))) (c)) (lebc))).
theorem nat.le_pred_n : forall (n:nat.nat) , (((nat.le_) ) (((nat.pred_) ) (n))) (n) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , (((nat.le_) ) (((nat.pred_) ) (_x_365))) (_x_365))) ((((((@nat.eq_match_nat_type_O) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (fun (y : nat.nat) , (((nat.le_) ) (((((nat.match_nat_type) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) ((nat.O) ))) (y))) ((@nat.le_n) (((nat.pred_) ) ((nat.O) ))))) (fun (x_366 : nat.nat) , fun (_x_368 : (((nat.le_) ) (((nat.pred_) ) (x_366))) (x_366)) , (((((((@nat.eq_match_nat_type_S) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (x_366)) (fun (y : nat.nat) , (((nat.le_) ) (((nat.pred_) ) (((nat.S) ) (x_366)))) (((nat.S) ) (y)))) ((@nat.le_n_Sn) (((nat.pred_) ) (((nat.S) ) (x_366))))))) (n).
theorem nat.monotonic_pred : (((relations.monotonic) (nat.nat)) ((nat.le_) )) ((nat.pred_) ) := fun (n : nat.nat) , fun (m : nat.nat) , fun (lenm : (((nat.le_) ) (n)) (m)) , (((((((@nat.le_ind) (n)) (fun (x_417 : nat.nat) , (((nat.le_) ) (((nat.pred_) ) (n))) (((nat.pred_) ) (x_417)))) ((@nat.le_n) (((nat.pred_) ) (n)))) (fun (m0 : nat.nat) , fun (_x_419 : (((nat.le_) ) (n)) (m0)) , (fun (_x_421 : (((nat.le_) ) (((nat.pred_) ) (n))) (((nat.pred_) ) (m0))) , ((((((@nat.transitive_le) (((nat.pred_) ) (n))) (n)) (((nat.pred_) ) (((nat.S) ) (m0)))) ((@nat.le_pred_n) (n))) (((((((@nat.sym_eq_match_nat_type_S) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (m0)) (fun (y : nat.nat) , (((nat.le_) ) (n)) (y))) (_x_419)))))) (m)) (lenm)).
theorem nat.not_le_Sn_O : forall (n:nat.nat) , ((connectives.Not) ) ((((nat.le_) ) (((nat.S) ) (n))) ((nat.O) )) := fun (n : nat.nat) , ((@connectives.nmk) ((((nat.le_) ) (((nat.S) ) (n))) ((nat.O) ))) (fun (Hlen0 : (((nat.le_) ) (((nat.S) ) (n))) ((nat.O) )) , ((((((@nat.eq_match_nat_type_O) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (fun (y : Prop) , y)) ((((@nat.lt_to_not_zero) (n)) ((nat.O) )) (Hlen0)))).
theorem nat.not_le_to_not_le_S_S : forall (n:nat.nat) , forall (m:nat.nat) , (((connectives.Not) ) ((((nat.le_) ) (n)) (m))) -> ((connectives.Not) ) ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m))) := fun (n : nat.nat) , fun (m : nat.nat) , fun (auto : ((connectives.Not) ) ((((nat.le_) ) (n)) (m))) , (((((@logic.not_to_not) ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m)))) ((((nat.le_) ) (n)) (m))) (fun (auto' : (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m))) , (((((@logic.eq_coerc) ((((nat.le_) ) (((nat.pred_) ) (((nat.S) ) (n)))) (((nat.pred_) ) (((nat.S) ) (m))))) ((((nat.le_) ) (n)) (m))) ((((@nat.monotonic_pred) (((nat.S) ) (n))) (((nat.S) ) (m))) (auto'))) (((((((@logic.rewrite_l) (nat.nat)) (n)) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (__)) (((nat.pred_) ) (((nat.S) ) (m))))) ((((nat.le_) ) (n)) (m)))) (((((((@logic.rewrite_l) (nat.nat)) (m)) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (n)) (__))) ((((nat.le_) ) (n)) (m)))) (((@logic.refl_) (Prop)) ((((nat.le_) ) (n)) (m)))) (((nat.pred_) ) (((nat.S) ) (m)))) ((@nat.pred_Sn) (m)))) (((nat.pred_) ) (((nat.S) ) (n)))) ((@nat.pred_Sn) (n)))))) (auto)).
theorem nat.decidable_le_ : forall (n:nat.nat) , forall (m:nat.nat) , ((logic.decidable) ) ((((nat.le_) ) (n)) (m)) := ((((@nat.nat_elim2) (fun (__ : nat.nat) , fun (_0 : nat.nat) , ((logic.decidable) ) ((((nat.le_) ) (__)) (_0)))) (fun (n : nat.nat) , (((@connectives.or_introl) ((((nat.le_) ) ((nat.O) )) (n))) (((connectives.Not) ) ((((nat.le_) ) ((nat.O) )) (n)))) ((@nat.le_O_n) (n)))) (fun (n : nat.nat) , (((@connectives.or_intror) ((((nat.le_) ) (((nat.S) ) (n))) ((nat.O) ))) (((connectives.Not) ) ((((nat.le_) ) (((nat.S) ) (n))) ((nat.O) )))) ((@nat.not_le_Sn_O) (n)))) (fun (n : nat.nat) , fun (m : nat.nat) , fun (_clearme : ((logic.decidable) ) ((((nat.le_) ) (n)) (m))) , (((((((@connectives.match_Or_prop) ((((nat.le_) ) (n)) (m))) (((connectives.Not) ) ((((nat.le_) ) (n)) (m)))) (((logic.decidable) ) ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m))))) (fun (auto : (((nat.le_) ) (n)) (m)) , ((((@connectives.or_introl) ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m)))) (((connectives.Not) ) ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m))))) ((((@nat.le_S_S) (n)) (m)) (auto))))) (fun (auto : ((connectives.Not) ) ((((nat.le_) ) (n)) (m))) , ((((@connectives.or_intror) ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m)))) (((connectives.Not) ) ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m))))) ((((@nat.not_le_to_not_le_S_S) (n)) (m)) (auto))))) (_clearme))).
theorem nat.decidable_lt_ : forall (n:nat.nat) , forall (m:nat.nat) , ((logic.decidable) ) ((((nat.lt_) ) (n)) (m)) := fun (n : nat.nat) , fun (m : nat.nat) , ((@nat.decidable_le_) (((nat.S) ) (n))) (m).
